	.dbfile C:\iccv7arm\MID7D7~1\MicroBolt_Rtc.c
	AREA	"C$$code", CODE, READONLY
	EXPORT _main
	.dbfunc e main _main fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_main:
	.dbline -1
	.dbline 38
; /*
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; | File Name			  : MicroBolt_Rtc.c																					
; | Author			    : Micromint, Inc.						
; | Copyright       : Copyright  2005, Micromint, Inc.																	
; | Creation Date		: 9/30/05																							
; | Version			    : 1.00																																												
; | Spaces per tab	:	2																									
; | Description		  : Main C file																																									 
; | Revision			  :	Initial																																																						
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; */
; 
; /*
; |----------------------------------------------------
; |     Includes
; |----------------------------------------------------
; */
; 
; #include <ARM/philips/lpc210x.h>
; #include <arm_macros.h>
; #include "MicroBolt_Rtc.h"
; #include "SerialDebugger.h"
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   main
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Main function for system
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void main(void)
;   {
	.dbline 39
;   __DISABLE_INTERRUPT();                        // Disable all interrupts
	mrs R12,cpsr
	orr R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 46
; 
; /*
; |-------------------------
; | Config MAM 
; |-------------------------
; */
;   MAM_CR = 0x00;                                // Turn MAM off (default)
	mov R0,#0
	ldr R1,LIT_main+0
	str R0,[R1,#0]
	.dbline 47
;   MAM_TIM = 0x04;                               // Set flash timing to 4 clock cycles
	mov R0,#4
	ldr R1,LIT_main+4
	str R0,[R1,#0]
	.dbline 49
; 
;   MAM_CR = 0x02;                                // Fully enable the Memory Accleration Module
	mov R0,#2
	ldr R1,LIT_main+0
	str R0,[R1,#0]
	.dbline 56
; 
; /*
; |-------------------------
; | Config PLL and CCLK 
; |-------------------------
; */
;   SCB_PLLCFG |= 0x23;				 	   		            // Set to 59 MHz (0x03 is multiply value of 4)
	ldr R0,LIT_main+8
	ldr R1,[R0,#0]
	orr R1,R1,#35
	str R1,[R0,#0]
	.dbline 57
;   SCB_PLLCON |= 0x01;                           // Enable the PLL 
	ldr R0,LIT_main+12
	ldr R1,[R0,#0]
	orr R1,R1,#1
	str R1,[R0,#0]
	.dbline 58
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R0,#170
	ldr R1,LIT_main+16
	str R0,[R1,#0]
	.dbline 59
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R0,#85
	ldr R1,LIT_main+16
	str R0,[R1,#0]
	.dbline 66
; 
; /*
; |-------------------------
; | Config PCLK 
; |-------------------------
; */
;   SCB_VPBDIV = 0;                               // Peripheral clock is 1/4th Processor clock which equals 14.7456 MHz
	mov R0,#0
	ldr R1,LIT_main+20
	str R0,[R1,#0]
	.dbline 73
; 
; /*
; |-------------------------
; | Configure VIC 
; |-------------------------
; */
;   VICVectAddr0 = (unsigned)pll_isr;             // Assign the PLL lock ISR vector address
	ldr R0,LIT_main+24
	ldr R1,LIT_main+28
	str R0,[R1,#0]
	.dbline 74
;   VICVectCntl0 = INTERRUPT_CHANNEL_FOR_PLL;     // Assign the VIC address to the actual interrupt
	mov R0,#44
	ldr R1,LIT_main+32
	str R0,[R1,#0]
	.dbline 75
;   VICIntEnable = INTERRUPT_ENABLE_FOR_PLL;      // Enable the interrupt  
	mov R0,#4096
	ldr R1,LIT_main+36
	str R0,[R1,#0]
	.dbline 77
; 
;   VICVectAddr1=(unsigned)rtc_isr;               // Assign the RTC ISR vector address
	ldr R0,LIT_main+40
	ldr R1,LIT_main+44
	str R0,[R1,#0]
	.dbline 78
;   VICVectCntl1 = INTERRUPT_CHANNEL_FOR_RTC;     // Assign the VIC address to the actual interrupt
	mov R0,#45
	ldr R1,LIT_main+48
	str R0,[R1,#0]
	.dbline 79
;   VICIntEnable = INTERRUPT_ENABLE_FOR_RTC;      // Enable the interrupt 
	mov R0,#8192
	ldr R1,LIT_main+36
	str R0,[R1,#0]
	.dbline 86
; 
; /*
; |-------------------------
; | Config GPIO 
; |-------------------------
; */
;   PCB_PINSEL0=0x00000005;                       // Setup with ICCARM App builder - MicroBolt_Rtc.bcf (UART0)   
	mov R0,#5
	ldr R1,LIT_main+52
	str R0,[R1,#0]
	.dbline 87
;   PCB_PINSEL1=0x55400000;                       //                                     (Secondary JTAG pins) 
	ldr R0,LIT_main+56
	ldr R1,LIT_main+60
	str R0,[R1,#0]
	.dbline 89
; 
;   GPIO_IODIR |= MICROBOLT_LED;                  // Setup MicroBolt LED as output
	ldr R0,LIT_main+64
	ldr R1,[R0,#0]
	orr R1,R1,#4194304
	str R1,[R0,#0]
	.dbline 91
; 
;   GPIO_IOCLR=0xffffffff;                        // Clear all pins to start with
	mvn R0,#0
	ldr R1,LIT_main+68
	str R0,[R1,#0]
	.dbline 98
; 
; /*
; |-------------------------
; | Config RTC 
; |-------------------------
; */
;   RTC_CCR=0;                                    // Configure of RTC done via Imagecraft App builder, open .bcf file to edit
	mov R0,#0
	ldr R1,LIT_main+72
	str R0,[R1,#0]
	.dbline 99
;   RTC_CIIR=0x00000001;          
	mov R0,#1
	ldr R1,LIT_main+76
	str R0,[R1,#0]
	.dbline 100
;   RTC_AMR=0x00000000;
	mov R0,#0
	ldr R1,LIT_main+80
	str R0,[R1,#0]
	.dbline 102
;                                                 // Set the time and date for the RTC - Dec 31, 2005 - 23:59:00 PM
;   RTC_SEC=0x00000000;
	mov R0,#0
	ldr R1,LIT_main+84
	str R0,[R1,#0]
	.dbline 103
;   RTC_MIN=0x0000003B;
	mov R0,#59
	ldr R1,LIT_main+88
	str R0,[R1,#0]
	.dbline 104
;   RTC_HOUR=0x00000017;
	mov R0,#23
	ldr R1,LIT_main+92
	str R0,[R1,#0]
	.dbline 105
;   RTC_DOM=0x0000001F;
	mov R0,#31
	ldr R1,LIT_main+96
	str R0,[R1,#0]
	.dbline 106
;   RTC_DOW=0x00000006;
	mov R0,#6
	ldr R1,LIT_main+100
	str R0,[R1,#0]
	.dbline 107
;   RTC_DOY=0x0000016B;
	ldr R0,LIT_main+104
	ldr R1,LIT_main+108
	str R0,[R1,#0]
	.dbline 108
;   RTC_MONTH=0x0000000C;
	mov R0,#12
	ldr R1,LIT_main+112
	str R0,[R1,#0]
	.dbline 109
;   RTC_YEAR=0x000007D5;
	ldr R0,LIT_main+116
	ldr R1,LIT_main+120
	str R0,[R1,#0]
	.dbline 111
; 
;   RTC_ALSEC=0x00000001;                         // Alarm setting if applicable
	mov R0,#1
	ldr R1,LIT_main+124
	str R0,[R1,#0]
	.dbline 112
;   RTC_ALMIN=0x00000001;
	mov R0,#1
	ldr R1,LIT_main+128
	str R0,[R1,#0]
	.dbline 113
;   RTC_ALHOUR=0x00000001;
	mov R0,#1
	ldr R1,LIT_main+132
	str R0,[R1,#0]
	.dbline 114
;   RTC_ALDOM=0x00000001;
	mov R0,#1
	ldr R1,LIT_main+136
	str R0,[R1,#0]
	.dbline 115
;   RTC_ALDOW=0x00000001;
	mov R0,#1
	ldr R1,LIT_main+140
	str R0,[R1,#0]
	.dbline 116
;   RTC_ALDOY=0x00000001;
	mov R0,#1
	ldr R1,LIT_main+144
	str R0,[R1,#0]
	.dbline 117
;   RTC_ALMON=0x00000001;
	mov R0,#1
	ldr R1,LIT_main+148
	str R0,[R1,#0]
	.dbline 118
;   RTC_ALYEAR=0x000007D0;
	mov R0,#2000
	ldr R1,LIT_main+152
	str R0,[R1,#0]
	.dbline 120
; 
;   RTC_PREINT=0x000001C1;                        // Configure the clock divisor for use with MicroBolt crystal - 14.7456 MHz/32.768 KHz
	ldr R0,LIT_main+156
	ldr R1,LIT_main+160
	str R0,[R1,#0]
	.dbline 121
;   RTC_PREFRAC=0x00000000;                       // Remainder of above division
	mov R0,#0
	ldr R1,LIT_main+164
	str R0,[R1,#0]
	.dbline 123
; 
;   RTC_CCR=0x00000001;                           // Start the RTC
	mov R0,#1
	ldr R1,LIT_main+72
	str R0,[R1,#0]
	.dbline 130
; 
; /*
; |-------------------------
; | Config UART-O 
; |-------------------------
; */
;   UART0_IER = 0x00000001;	 	                    // Receive interrupts
	mov R0,#1
	ldr R1,LIT_main+168
	str R0,[R1,#0]
	.dbline 131
;   UART0_FCR = 0x00000001;	 	                    // Enable the fifos
	mov R0,#1
	ldr R1,LIT_main+172
	str R0,[R1,#0]
	.dbline 132
;   UART0_LCR = 0x00000083;	 	                    // Enable the divisor
	mov R0,#131
	ldr R1,LIT_main+176
	str R0,[R1,#0]
	.dbline 133
;   UART0_DLM = 0;				                        // Divisor latch MSB (for baud rates < 4800) 
	mov R0,#0
	ldr R1,LIT_main+168
	str R0,[R1,#0]
	.dbline 134
;   UART0_DLL = BAUD_RATE_115200;			            // Divisor latch LSB 
	mov R0,#8
	ldr R1,LIT_main+180
	str R0,[R1,#0]
	.dbline 135
;   UART0_LCR = 0x00000003;  	                    // Close it, then UART works with divisor
	mov R0,#3
	ldr R1,LIT_main+176
	str R0,[R1,#0]
	.dbline 137
; 
;   __ENABLE_INTERRUPT();                         // Enable all interrupts
	mrs R12,cpsr
	bic R12,R12,#0x80
	msr cpsr_c,R12
	
L2:
	.dbline 146
	.dbline 147
L3:
	.dbline 145
	b L2
X0:
	.dbline -2
L1:
	mov R15,R14
	.dbline 0 ; func end
LIT_main:
	DCD -534790144
	DCD -534790140
	DCD -534790012
	DCD -534790016
	DCD -534790004
	DCD -534789888
	DCD _pll_isr
	DCD -3840
	DCD -3584
	DCD -4080
	DCD _rtc_isr
	DCD -3836
	DCD -3580
	DCD -536690688
	DCD 1430257664
	DCD -536690684
	DCD -536707064
	DCD -536707060
	DCD -536723448
	DCD -536723444
	DCD -536723440
	DCD -536723424
	DCD -536723420
	DCD -536723416
	DCD -536723412
	DCD -536723408
	DCD 363
	DCD -536723404
	DCD -536723400
	DCD 2005
	DCD -536723396
	DCD -536723360
	DCD -536723356
	DCD -536723352
	DCD -536723348
	DCD -536723344
	DCD -536723340
	DCD -536723336
	DCD -536723332
	DCD 449
	DCD -536723328
	DCD -536723324
	DCD -536821756
	DCD -536821752
	DCD -536821748
	DCD -536821760
	.dbend
	EXPORT _pll_isr
	.dbfunc e pll_isr _pll_isr fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_pll_isr:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 163
; 
; /*
; |----------------------------------------------------
; |     Start of application
; |----------------------------------------------------
; */
; 
;   while(1)                                      // Do this forever
;     {
;     }
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   pll_isr
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Once PLL has locked, connect it and use for system clock
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; #pragma interrupt_handler pll_isr
; 
; void pll_isr(void)
;   {
	.dbline 164
;   SCB_PLLCON |= 0x02;                           // Connect the PLL 
	ldr R0,LIT_pll_isr+0
	ldr R1,[R0,#0]
	orr R1,R1,#2
	str R1,[R0,#0]
	.dbline 165
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R0,#170
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 166
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R0,#85
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 167
;   VICIntEnClear = PLL_CLR;                      // Disable the PLL interrupt, not needed anymore
	mov R0,#4096
	ldr R1,LIT_pll_isr+8
	str R0,[R1,#0]
	.dbline 168
;   VICVectAddr = VIC_ACK;                        // Acknowledge Interrupt
	mov R0,#0
	ldr R1,LIT_pll_isr+12
	str R0,[R1,#0]
	.dbline -2
L5:
	ldmfd R13!,{R0,R1,R11,R12,PC}^
	.dbline 0 ; func end
LIT_pll_isr:
	DCD -534790016
	DCD -534790004
	DCD -4076
	DCD -4048
	.dbend
	EXPORT _rtc_isr
	.dbfunc e rtc_isr _rtc_isr fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;          Delay -> R6
_rtc_isr:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R2,R3,R4,R5,R6,R11,R12,R14}
	mov R11,R13
	sub R13,R13,#0x4
	.dbline -1
	.dbline 184
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   rtc_isr
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Interrupt every second
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; #pragma interrupt_handler rtc_isr
; 
; void rtc_isr(void)
;   {
	.dbline 187
;   unsigned int Delay;
; 
;   SerialDebugLed(LED_ON);                                         // MicroBolt Serial Debugger LED on
	mov R0,#1
	bl _SerialDebugLed
	.dbline 189
; 
;   SerialDebug(1,"Date: %d/%d/%d",RTC_MONTH, RTC_DOM, RTC_YEAR);   // Output string to MicroBolt Serial Debugger Debug window 1
	mov R0,#1
	ldr R1,LIT_rtc_isr+0
	ldr R4,LIT_rtc_isr+4
	ldr R2,[R4,#0]
	ldr R4,LIT_rtc_isr+8
	ldr R3,[R4,#0]
	ldr R4,LIT_rtc_isr+12
	ldr R4,[R4,#0]
	str R4,[R13,#0]
	bl _SerialDebug
	.dbline 190
;   SerialDebug(2,"Time: %d:%d:%d",RTC_HOUR, RTC_MIN, RTC_SEC);     // Output string to MicroBolt Serial Debugger Debug window 2  
	mov R0,#2
	ldr R1,LIT_rtc_isr+16
	ldr R4,LIT_rtc_isr+20
	ldr R2,[R4,#0]
	ldr R4,LIT_rtc_isr+24
	ldr R3,[R4,#0]
	ldr R4,LIT_rtc_isr+28
	ldr R4,[R4,#0]
	str R4,[R13,#0]
	bl _SerialDebug
	.dbline 192
; 
;   GPIO_IOSET = MICROBOLT_LED;                                     // MicroBolt LED on
	mov R4,#4194304
	ldr R5,LIT_rtc_isr+32
	str R4,[R5,#0]
	.dbline 193
	mov R6,#0
	b L12
L9:
	.dbline 193
L10:
	.dbline 193
	add R6,R6,#1
L12:
	.dbline 193
;   for (Delay = 0; Delay < 100000; Delay++);                       // Delay for a few
	ldr R4,LIT_rtc_isr+36
	cmp R6,R4
	blo L9
	.dbline 194
;   GPIO_IOCLR = MICROBOLT_LED;                                     // MicroBolt LED off
	mov R4,#4194304
	ldr R5,LIT_rtc_isr+40
	str R4,[R5,#0]
	.dbline 196
; 
;   SerialDebugLed(LED_OFF);                                        // MicroBolt Serial Debugger LED off
	mov R0,#0
	bl _SerialDebugLed
	.dbline 198
; 
;   RTC_ILR = RTC_CLR;                                              // Clear RTC interrupt
	mov R4,#3
	ldr R5,LIT_rtc_isr+44
	str R4,[R5,#0]
	.dbline 199
;   VICVectAddr = VIC_ACK;                                          // Acknowledge Interrupt
	mov R4,#0
	ldr R5,LIT_rtc_isr+48
	str R4,[R5,#0]
	.dbline -2
L6:
	add R13,R13,#0x4
	ldmfd R13!,{R0,R1,R2,R3,R4,R5,R6,R11,R12,PC}^
	.dbline 0 ; func end
LIT_rtc_isr:
	DCD L7
	DCD -536723400
	DCD -536723412
	DCD -536723396
	DCD L8
	DCD -536723416
	DCD -536723420
	DCD -536723424
	DCD -536707068
	DCD 100000
	DCD -536707060
	DCD -536723456
	DCD -4048
	.dbsym r Delay 6 i
	.dbend
	AREA	"C$$code", CODE, READONLY
L8:
	DCB "Time: %d:%d:%d", 0
L7:
	DCB "Date: %d/%d/%d", 0
	END
