	.dbfile C:\iccv7arm\MID7D7~1\SerialDebugger.c
	AREA	"C$$code", CODE, READONLY
	EXPORT _SerialDebug
	.dbfunc e SerialDebug _SerialDebug fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;             va -> R4
;            fmt -> R11,20
;    DebugBoxNum -> R11,16
_SerialDebug:
	mov R12,R13
	stmfd R13!,{R0-R3}
	stmfd R13!,{R4,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 52
; /*
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; | File Name			  : SerialDebugger.c																					
; | Author			    : Micromint, Inc.						
; | Copyright       : Copyright  2005, Micromint, Inc.																	
; | Creation Date		: 9/30/05																							
; | Version			    : 1.00																																												
; | Spaces per tab	:	2																									
; | Description		  : Main C file																																									 
; | Revision			  :	Initial																																																						
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; */
; 
; /*
; |----------------------------------------------------
; |     Includes
; |----------------------------------------------------
; */
; 
; #include <ARM/philips/lpc210x.h>
; #include <arm_macros.h>
; #include <STDIO.h>
; #include <STDARG.h>
; 
; #include "SerialDebugger.h"
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   main
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Main function for system
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; extern int _textmode;		                        // This is defined in the ICCARM library 
; 		
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   SerialDebug
; |     Inputs          :   Printf for serial debugger
; |     Outputs         :   None
; |     Purpose         :   Transmit data to the PEC Serial Debugger
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void SerialDebug(char DebugBoxNum, char *fmt,...)
;     {
	.dbline 54
;       va_list va;
;       va_start(va, fmt);          
	add R4,R11,#0x18
	.dbline 55
;       printf("%d", DebugBoxNum);
	ldr R0,LIT_SerialDebug+0
	ldrb R1,[R11,#+16]
	bl _printf
	.dbline 56
;       vprintf(fmt,va);
	ldr R0,[R11,#+20]
	mov R1,R4
	bl _vprintf
	.dbline 57
;       printf("\n");
	ldr R0,LIT_SerialDebug+4
	bl _printf
	.dbline -2
L1:
	ldmfd R11,{R4,R11,SP,PC}
	.dbline 0 ; func end
LIT_SerialDebug:
	DCD L3
	DCD L4
	.dbsym r va 4 pc
	.dbsym l fmt 20 pc
	.dbsym l DebugBoxNum 16 c
	.dbend
	EXPORT _SerialDebugLed
	.dbfunc e SerialDebugLed _SerialDebugLed fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;     LedOnOrOff -> R5
_SerialDebugLed:
	mov R12,R13
	stmfd R13!,{R4,R5,R11,R12,R14}
	mov R11,R13
	mov R5,R0
	.dbline -1
	.dbline 71
;     }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   SerialDebugLed
; |     Inputs          :   LED for serial debugger
; |     Outputs         :   None
; |     Purpose         :   Transmit data to the PEC Serial Debugger
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void SerialDebugLed(char LedOnOrOff)
;     {
	.dbline 72
;       if (LedOnOrOff == LED_ON)
	and R4,R5,#255
	cmp R4,#1
	bne L6
	.dbline 73
;         {
	.dbline 74
;         printf("L1\n");
	ldr R0,LIT_SerialDebugLed+0
	bl _printf
	.dbline 75
;         }
	b L7
L6:
	.dbline 77
;       else
;       if (LedOnOrOff == LED_OFF)
	ands R4,R5,#255
	bne L9
	.dbline 78
;         {
	.dbline 79
;         printf("L0\n");
	ldr R0,LIT_SerialDebugLed+4
	bl _printf
	.dbline 80
;         }
L9:
L7:
	.dbline -2
L5:
	ldmfd R11,{R4,R5,R11,SP,PC}
	.dbline 0 ; func end
LIT_SerialDebugLed:
	DCD L8
	DCD L11
	.dbsym r LedOnOrOff 5 c
	.dbend
	EXPORT _putchar
	.dbfunc e putchar _putchar fI
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;     SerialByte -> R6
_putchar:
	mov R12,R13
	stmfd R13!,{R4,R5,R6,R11,R12,R14}
	mov R11,R13
	mov R6,R0
	.dbline -1
	.dbline 95
;     }
; 
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   putchar
; |     Inputs          :   Byte for transmission
; |     Outputs         :   None
; |     Purpose         :   Transmit a byte via UART0 to enable printf
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; int putchar(char SerialByte)
;   {
	.dbline 96
;   _textmode = 1;                                // Turn carriage return line feed on for printf
	mov R4,#1
	ldr R5,LIT_putchar+0
	str R4,[R5,#0]
	.dbline 97
;   if (_textmode == 1 && SerialByte == '\n')
	ldr R4,LIT_putchar+0
	ldr R4,[R4,#0]
	cmp R4,#1
	bne L16
	and R4,R6,#255
	cmp R4,#10
	bne L16
	.dbline 98
;       {
	.dbline 99
;       putchar('\r');
	mov R0,#13
	bl _putchar
	.dbline 100
;       }
L15:
	.dbline 101
L16:
	.dbline 101
;   while (!(UART0_LSR & 0x20)); 
	ldr R4,LIT_putchar+4
	ldr R4,[R4,#0]
	tst R4,#32
	beq L15
	.dbline 102
;   UART0_THR = SerialByte;
	and R4,R6,#255
	ldr R5,LIT_putchar+8
	str R4,[R5,#0]
	.dbline 103
;   return SerialByte;
	and R0,R6,#255
	.dbline -2
L12:
	ldmfd R11,{R4,R5,R6,R11,SP,PC}
	.dbline 0 ; func end
LIT_putchar:
	DCD __textmode
	DCD -536821740
	DCD -536821760
	.dbsym r SerialByte 6 c
	.dbend
	IMPORT __textmode
	AREA	"C$$code", CODE, READONLY
L11:
	DCB "L0", 10, 0
L8:
	DCB "L1", 10, 0
L4:
	DCB 10, 0
L3:
	DCB "%d", 0
	END
